var w = Object.defineProperty;
var m = (o, t, a) => t in o ? w(o, t, { enumerable: !0, configurable: !0, writable: !0, value: a }) : o[t] = a;
var u = (o, t, a) => (m(o, typeof t != "symbol" ? t + "" : t, a), a);
class d extends Error {
  constructor(a, e, n, r) {
    super(a);
    u(this, "chunkedFile");
    u(this, "response");
    u(this, "originalError");
    this.chunkedFile = e, this.response = n, this.originalError = r;
  }
}
function b(o, t, a, e) {
  let n = 0, r = t;
  const s = [];
  for (; n < o.size; )
    s.push({ blob: o.slice(n, r), index: s.length, isUploaded: !1, uploaded: 0 }), n = r, r = n + t;
  return {
    chunks: s,
    originalFile: o,
    uid: a,
    callback: e
  };
}
async function f(o, t, a, e) {
  const n = new Headers();
  e.headers.Authorization && n.append("Authorization", e.headers.Authorization);
  let r;
  if (e.setFormData)
    r = e.setFormData(t, a);
  else {
    r = new FormData();
    const l = new Blob([t.blob], { type: a.originalFile.type });
    r.append("file", l, a.originalFile.name), r.append("metadata.uploadUid", a.uid), r.append("metadata.chunkIndex", t.index.toString()), r.append("metadata.totalChunks", a.chunks.length.toString()), r.append("metadata.totalFileSize", a.originalFile.size.toString());
  }
  const s = new XMLHttpRequest(), i = await new Promise((l) => {
    s.upload.addEventListener("progress", (c) => {
      c.lengthComputable && (t.uploaded = t.blob.size < c.loaded ? t.blob.size : c.loaded, a.callback && a.callback(h(a), a.uid));
    }), s.addEventListener("loadend", () => {
      l(s.readyState === 4 && Math.floor(s.status / 100) === 2);
    }), s.open("POST", o, !0), s.send(r);
  }), p = JSON.parse(s.response);
  if (i)
    return t.isUploaded = !0, p;
  throw t.isUploaded = !1, t.uploaded = 0, new d("Upload failed", a, p);
}
async function g(o, t, a) {
  try {
    const e = t.chunks.filter((i) => !i.uploaded), n = e.length;
    n >= 2 && await f(o, e[0], t, a);
    const r = e.slice(1, -1).map((i) => f(o, i, t, a));
    await Promise.all(r);
    const s = await f(o, e[n - 1], t, a);
    if (!s)
      throw new d("Failed to upload", t);
    return {
      result: s,
      file: t.originalFile,
      uid: t.uid
    };
  } catch (e) {
    throw e instanceof d ? e : e instanceof Error ? new d(e.message, t, void 0, e) : new d("No actual error was thrown", t);
  }
}
function h(o) {
  return o.chunks.reduce((a, e) => a + e.uploaded, 0) / o.originalFile.size;
}
const U = 5 * 1024 * 1024;
function y(o, t = {}) {
  const e = {
    ...{
      chunkSize: U,
      headers: {},
      progressPollInterval: 500
    },
    ...t
  };
  async function n(s, i, p) {
    const l = b(s, e.chunkSize, i, p);
    return g(o, l, e);
  }
  async function r(s) {
    return g(o, s, e);
  }
  return { uploadFile: n, retryUpload: r };
}
export {
  d as UploadFailedError,
  y as useChunkUpload
};
